---
title: 'ARIA: dialog role'
slug: Web/Accessibility/ARIA/Roles/dialog_role
tags:
  - ARIA
  - Accessibility
  - NeedsContent
  - Web Development
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p><span class="seoSummary">The <code><a class="external" href="http://www.w3.org/TR/2009/WD-wai-aria-20091215/roles#dialog" title="http://www.w3.org/TR/2009/WD-wai-aria-20091215/roles#alertdialog">dialog</a></code> role is used to mark up an HTML based application dialog or window that separates content or UI from the rest of the web application or page. Dialogs are generally placed on top of the rest of the page content using an overlay. Dialogs can be either non-modal (it's still possible to interact with content outside of the dialog) or modal (only the content in the dialog can be interacted with).</span></p>

<pre class="brush: html notranslate">&lt;div <strong>role="dialog" aria-labelledby="dialog1Title" aria-describedby="dialog1Desc"</strong>&gt;
  &lt;h2 <strong>id="dialog1Title"</strong>&gt;Your personal details were successfully updated&lt;/h2&gt;
  &lt;p <strong>id="dialog1Desc"</strong>&gt;You can change your details at any time in the user account section.&lt;/p&gt;
  &lt;button&gt;Close&lt;/button&gt;
&lt;/div&gt;</pre>

<h2 id="Description">Description</h2>

<p>Marking up a dialog element with the <code>dialog</code> role helps assistive technology identify the dialog's content as being grouped and separated from the rest of the page content. However, adding <code>role="dialog"</code> alone is not sufficient to make a dialog accessible. Additionally, the following needs to be done:</p>

<ul>
 <li>The dialog must be properly labeled</li>
 <li>Keyboard focus must be managed correctly </li>
</ul>

<p>The sections below describe how these two requirements can be met.</p>

<h4 id="Labeling">Labeling</h4>

<p>Even though it is not required for the dialog itself to be able to receive focus, it still needs to be labeled. The label given to the dialog will provide contextual information for the interactive controls inside the dialog. In other words, the dialog's label acts like a grouping label for the controls inside it (similar to how a <code>&lt;legend&gt;</code> element provides a grouping label for the controls inside a <code>&lt;fieldset&gt;</code> element).</p>

<p>If a dialog already has a visible title bar, the text inside that bar can be used to label the dialog itself. The best way to achieve this is by using the <code>aria-labelledby</code> attribute to the <code>role="dialog"</code> element. Additionally, if the dialog contains additional descriptive text besides the dialog title, this text can be associated with the dialog using the <code>aria-describedby</code> attribute. This approach is shown in the code snippet below:</p>

<pre class="brush: html notranslate">&lt;div <strong>role="dialog" aria-labelledby="dialog1Title" aria-describedby="dialog1Desc"</strong>&gt;
  &lt;h2 <strong>id="dialog1Title"</strong>&gt;Your personal details were successfully updated&lt;/h2&gt;
  &lt;p <strong>id="dialog1Desc"</strong>&gt;You can change your details at any time in the user account section.&lt;/p&gt;
  &lt;button&gt;Close&lt;/button&gt;
&lt;/div&gt;</pre>

<div class="note">Keep in mind that a dialog's title and description text do not have to be focusable in order to be perceived by screen readers operating in a non-virtual mode. The combination of the ARIA dialog role and labeling techniques should make the screen reader announce the dialog's information when focus is moved into it.</div>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<h4 id="Focus_management">Focus management </h4>

<p>A dialog has particular requirements for how keyboard focus should be managed:</p>

<ul>
 <li>Dialogs should always have at least one focusable control. For many dialogs, there will be a button like "Close", "OK" or "Cancel". In addition to the needed control, dialogs can contain any number of focusable elements, even entire forms or other container widgets like tabs.</li>
 <li>When the dialog appears on the screen, keyboard focus (whose control depends upon the dialogs purpose) should be moved to the default focusable control inside the dialog. For dialogs that only provide a basic message, it could be an "OK" button. For dialogs containing a form it could be the first field in the form.</li>
 <li>After the dialog is dismissed, keyboard focus should be moved back to where it was before it moved into the dialog. Otherwise the focus can be dropped to the beginning of the page.</li>
 <li>For most dialogs, the expected behavior is that the dialog's tab order <em>wraps</em>, which means that when the user tabs through the focusable elements in the dialog, the first focusable element will be focused after the last one has been reached. In other words, the tab order should be contained within and by the dialog.</li>
 <li>If the dialog can be moved or resized, ensure that these actions must be performable by keyboard users as well as mouse users. Similarly, if a dialog provides special features like toolbars or context menus, these must be reachable and operable by keyboard users as well.</li>
 <li>Dialogs can be modal or non-modal. When a <em>modal</em> dialog appears on the screen, it's not possible to interact with any page content outside the dialog. In other words, the main application UI or page content is considered to be temporarily disabled as long as the modal dialog is showing. For <em>non-modal </em>dialogs it is still possible to interact with content outside of the dialog while the dialog is showing. Note that for non-modal dialogs there will have to be a global keyboard shortcut that allows focus to be moved between opened dialogs and the main page. For more information see the <a href="/en-US/docs/ARIA/ARIA_Guides/Managing_Modal_and_Non_Modal_Dialogs">Managing Modal and Non Modal Dialogs</a> guide.</li>
</ul>

<h3 id="Associated_ARIA_roles_states_and_properties">Associated ARIA roles, states, and properties</h3>

<dl>
 <dt><code><span class="highlight-span">aria-labelledby</span></code></dt>
 <dd><span class="highlight-span">Use this attribute to label the dialog. Often, the value of the aria-labelledby attribute will be the id of the element used to title the dialog.</span></dd>
 <dt><code>aria-describedby</code></dt>
 <dd>Use this attribute to describe the contents of the dialog.</dd>
</dl>

<h3 id="Possible_effects_on_user_agents_and_assistive_technology">Possible effects on user agents and assistive technology </h3>

<p>When the <code>dialog</code> role is used, the user agent should do the following:</p>

<ul>
 <li>Expose the element as a dialog in the operating system's accessibility API.</li>
</ul>

<p>When the dialog is correctly labeled and focus is moved to an element (often an interactive element, such as a button) inside the dialog, screen readers should announce the dialog's accessible role, name and optionally description, along with announcing the focused element. </p>

<div class="note"><strong>Note:</strong> Opinions may differ on how assistive technology should handle this technique, and the order of announcements may differ depending on the assistive technolgy used. The information provided above is one of those opinions and therefore not normative.</div>

<h2 id="Examples">Examples</h2>

<h4 id="A_dialog_containing_a_form">A dialog containing a form</h4>

<pre class="brush: html notranslate"> &lt;div role="dialog" aria-labelledby="dialog1Title" aria-describedby="dialog1Desc"&gt;
   &lt;h2 id="dialog1Title"&gt;Subscription Form&lt;/h2&gt;
   &lt;p id="dialog1Desc"&gt;We will not share this information with third parties.&lt;/p&gt;
   &lt;form&gt;
     &lt;p&gt;
       &lt;label for="firstName"&gt;First Name&lt;/label&gt;
       &lt;input id="firstName" type="text" /&gt;
     &lt;/p&gt;
     &lt;p&gt;
       &lt;label for="lastName"&gt;Last Name&lt;/label&gt;
       &lt;input id="lastName" type="text"/&gt;
     &lt;/p&gt;
     &lt;p&gt;
       &lt;label for="interests"&gt;Interests&lt;/label&gt;
       &lt;textarea id="interests"&gt;&lt;/textarea&gt;
     &lt;/p&gt;
     &lt;p&gt;
       &lt;input type="checkbox" id="autoLogin"/&gt;
       &lt;label for="autoLogin"&gt;Auto-login?&lt;/label&gt;
     &lt;/p&gt;
     &lt;p&gt;
         &lt;input type="submit" value="Save Information"/&gt;
     &lt;/p&gt;
   &lt;/form&gt;
 &lt;/div&gt;</pre>

<h4 id="Working_Examples">Working Examples:</h4>

<ul>
 <li><a class="external" href="http://jqueryui.com/demos/dialog/">jQuery-UI Dialog</a></li>
</ul>

<h3 id="Notes">Notes </h3>

<div class="note"><strong>Note:</strong> While it is possible to prevent keyboard users from moving focus to elements outside of the dialog, screen reader users may still be able to navigate to that content using their screen reader's virtual cursor. It is important for developers to ensure that content outside of the modal dialog is inaccessible to all users while the modal dialog is active.</div>

<ul>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#alert","alert")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>Coming soon</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Alertdialog_Role">ARIA: alertdialog role</a></li>
 <li><a href="/en/ARIA/ARIA_Techniques/Using_the_alertdialog_role" title="Using the alertdialog role">Using the alertdialog role</a></li>
</ul>
